using Microsoft.AspNetCore.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.Diagnostics;
using System.IO;
using System.Text;

namespace TestProject.Pages
{
    /// <summary>
    ///  
    /// </summary>
    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public class ErrorModel : PageModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region û ID - RequestID

        /// <summary>
        /// û ID
        /// </summary>
        public string RequestID { get; set; }

        #endregion
        #region û ID ǥ  - ShowRequestID

        /// <summary>
        /// û ID ǥ 
        /// </summary>
        public bool ShowRequestID => !string.IsNullOrEmpty(RequestID);

        #endregion
        #region  ޽ - ExceptionMessage

        /// <summary>
        ///  ޽
        /// </summary>
        public string ExceptionMessage { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - ErrorModel()

        /// <summary>
        /// 
        /// </summary>
        public ErrorModel()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GET û óϱ - OnGet()

        /// <summary>
        /// GET û óϱ
        /// </summary>
        public void OnGet()
        {
            RequestID = Activity.Current?.Id ?? HttpContext.TraceIdentifier;

            IExceptionHandlerPathFeature feature = HttpContext.Features.Get<IExceptionHandlerPathFeature>();

            StringBuilder stringBuilder = new StringBuilder();

            if(feature?.Error is FileNotFoundException)
            {
                stringBuilder.Append("File error thrown");
            }
            else
            {
                stringBuilder.Append("Error thrown");
            }

            if(feature?.Path == "/" || feature?.Path == "/index")
            {
                stringBuilder.Append(" from home page");
            }
            else
            {
                stringBuilder.Append($" from {feature?.Path}");
            }

            ExceptionMessage = stringBuilder.ToString();
        }

        #endregion
    }
}